Unit Keyboard;

Interface


Const
 key_esc  =01;
 key_ctrl =29;
 key_prev =73;
 key_alt  =56;
 key_up   =72;
 key_left =75;
 key_right=77;
 key_down =80;
 key_next =81;
 key_sup  =83;


Var
 Keys:array[0..128] of boolean;

Procedure Init;
Procedure Done;

Implementation

{ Keyboard Support }
Var
 Int09:pointer;
 Key:ShortInt;

Procedure KeyboardHandler; interrupt;
 Var
  Dummy:byte;
 begin
  Byte(Key):=Port[$60];

  dummy:=Port[$61];
  Port[$61]:=dummy or $80;
  Port[$61]:=dummy;

  Keys[Key and $7F]:=(Key>0);

  Port[$20]:=$20;

  if  keys[key_sup]
  and keys[key_ctrl]
  and keys[key_alt] then begin
   asm mov ax,03h; int 10h end;
   writeln('Keep cool !');
   halt;
  end;

 end;

Var
 OldExit:pointer;

Procedure Done;
 begin
  ExitProc:=OldExit;
  asm
   push ds
    lds dx,Int09
    mov ax,2509h
    int 21h
   pop  ds
  end;
 end;

Procedure Init;
 begin
  Fillchar(Keys,SizeOf(Keys),False);
  asm
   push ds
    mov ax,cs
    mov ds,ax
    mov dx,offset KeyboardHandler
    mov ax,2509h;
    int 21h
   pop  ds
  end;
  OldExit :=ExitProc;
  ExitProc:=@Done;
 end;

var
 k1:byte absolute $40:$17;
           { bit 7 =1 INSert active
             bit 6 =1 Caps Lock active
             bit 5 =1 Num Lock active
             bit 4 =1 Scroll Lock active
             bit 3 =1 either Alt pressed
             bit 2 =1 either Ctrl pressed
             bit 1 =1 Left Shift pressed
             bit 0 =1 Right Shift pressed }
 k2:byte absolute $40:$18;
           { bit 7 =1 INSert pressed
             bit 6 =1 Caps Lock pressed
             bit 5 =1 Num Lock pressed
             bit 4 =1 Scroll Lock pressed
             bit 3 =1 Pause state active
             bit 2 =1 Sys Req pressed
             bit 1 =1 Left Alt pressed
             bit 0 =1 Left Ctrl pressed }
function AnyKey:boolean;
 begin
  AnyKey:=(k2>0)or((k1 and 15)>0)or(Port[$60]<128);
 end;

begin
 if (Port[$60]>0) and AnyKey then begin
  writeln('Please, release all keys...');
  while AnyKey do;
 end;

 asm
  mov ax,3509h { get old Keyboard int }
  int 21h
  mov word(Int09+0),bx
  mov word(Int09+2),es
 end;

end.